<template>
  <div id="Messenger">
    <transition-group id="list" name="list" tag="p">
      <div
        :class="'message ' + msg.type"
        v-for="msg in messages"
        :key="msg.id"
        @click="removeMsg(msg.id)"
      >
        <h4 class="typeName" v-if="msg.title">{{ msg.title }}</h4>
        <pre class="text">{{ msg.text }}</pre>
      </div>
    </transition-group>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */
import { Component, Vue } from "vue-property-decorator";
import { Message, commit } from "@/store/messages";
import store from "@/store";

@Component
export default class Messenger extends Vue {
  get messages(): Message[] {
    return store.state.messages.messages;
  }

  removeMsg(msgId: string): void {
    store.commit(commit.clear, msgId);
  }
}
</script>

<style scoped>
#Messenger {
  z-index: 10;
  position: fixed;
  bottom: 0;
  max-width: 100vw;
  overflow: hidden;
}
#list {
  margin-bottom: 0;
  margin-left: 15px;
  display: flex;
  flex-direction: column-reverse;
  align-items: flex-start;
}

.message {
  cursor: pointer;
  font-size: 0.7em;
  margin-bottom: 1vh;
  padding: 10px 20px 10px 20px;

  border-left: solid 1vh;
  color: #fff;
  text-align: left;
  border-radius: 15px;
  transition: filter 0.1s;
  overflow: hidden;
  background-color: var(--info);
}

.message:hover {
  filter: brightness(90%);
}

.text {
  font-size: 1.1em;
  padding: 0;
  margin: 0;
}
.typeName {
  font-size: 1.2em;
}

/* Transition */
.list-enter-active,
.list-leave-active {
  transition: opacity 1s, margin 1s, padding 1s;
}
.list-enter, .list-leave-to /* .list-leave-active below version 2.1.8 */ {
  opacity: 0;
  padding-top: 0;
  padding-bottom: 0;
  margin-bottom: 0;
}

/* All colors */
.message.green {
  background-color: var(--green);
  border-color: var(--greenDark);
}
.message.red {
  background-color: var(--red);
  border-color: var(--redDark);
}
.message.yellow {
  background-color: var(--yellow);
  border-color: var(--yellowDark);
}
.message.white {
  background-color: white;
  border-color: lightgray;
  color: black;
}
</style>
